package fixtures;
import com.samscdrental.dataaccess.*;
import com.samscdrental.failures.FormatDeviation;
import com.samscdrental.model.CDCategory;
import com.samscdrental.model.CDCategoryValue;
import com.samscdrental.model.adt.Count;
import com.samscdrental.model.adt.Dollar;

public class CDCategoryValues {
	 private CDCategory category;
	  private int rentalDays;
	  private double baseRentalFee;
	  private double extraDayRentalFee; 
  public void setCategory(String category) throws FormatDeviation {

			this.category = CDCategory.parseString(category);
	
  }

  public void setRentalDays(int days) {
	    this.rentalDays = days;

  }

  public void setBaseRentalFee(double fee) {
	   this.baseRentalFee = fee;

  }

  public void setExtraDayRentalFee(double fee) {
	  this.extraDayRentalFee = fee;
	  
  }

  public void execute() {
	   Count CountRentalDays = new Count(rentalDays);
	    Dollar DollarBaseRentalFee = new Dollar(baseRentalFee);
	    Dollar DollarExtraDayRentalFee = new Dollar(extraDayRentalFee);

	    CDCategoryValue aCategoryValue = new CDCategoryValue
	    (category, CountRentalDays,
	        DollarBaseRentalFee,DollarExtraDayRentalFee);

	    CategoryValuesAccess.addCategoryValue(aCategoryValue);
  }
}
