package fixtures;
import com.samscdrental.model.*;
import com.samscdrental.model.adt.*;
import com.samscdrental.dataaccess.*;
import com.samscdrental.failures.*;
public class CdLibraryDriver {
  Customer customer;
  CD cd; 
  PhysicalIDADT physicalID;
  CustomerIDADT customerId; 
  RentalContract theRentalForm; 
  RentalCharge theRentalChargeForm ;
  TimeStamp theTimeStamp = TimeStamp.DEFAULT_VALUE; 
  TimeStamp makeTimeStamp(String date, String time) throws FormatDeviation
  {
	  String t = date + " " + time; 
	 TimeStamp x = TimeStamp.parseString(t); 
	 return x; 
  }
  public String echo(String data) {
    return data;
  }

  public void clearRentalStatusOf(String cdId) throws FormatDeviation {
	  physicalID = PhysicalIDADT.parseString(cdId); 

  }
  String time = "12:00 PM"; 
  public void setTime(String time) {
	  this.time = time; 
	  try {
		TimeStamp.TEST_ONLY_set_date(date + " " + time);
		theTimeStamp = this.makeTimeStamp(date, time);
	} catch (FormatDeviation e) {
		System.err.println("Bad date /time");
		theTimeStamp = TimeStamp.DEFAULT_VALUE; 
	} 
  }
  String date = "1/1/1970"; 
  public void setDate(String date) {
	  this.date = date; 
	  try {
		     TimeStamp.TEST_ONLY_set_date(date + " " + time);
			theTimeStamp = this.makeTimeStamp(date, time);
		} catch (FormatDeviation e) {
			System.err.println("Bad date /time");
			theTimeStamp = TimeStamp.DEFAULT_VALUE; 
		}

	     
  }

  public void rentCdToUser(String cdId, String user) throws FormatDeviation {
	  customerId = CustomerIDADT.parseString(user); 
	  physicalID = PhysicalIDADT.parseString(cdId); 
	  theRentalForm = RentalProcess.checkOut( customerId, physicalID   );
  }

  public boolean cdIsRentedTo(String cdId, String user) throws FormatDeviation
  	{
	  physicalID = PhysicalIDADT.parseString(cdId); 
	  customerId = CustomerIDADT.parseString(user); 
	  cd = CDAccess.findByPhysicalID(physicalID); 
	  if (!cd.getRented().equals(YesNo.YES))
		  return false;  
	  if (cd.getCustomerID().equals(customerId))
		  return true;
	  else 
		  return false;
  }

  public boolean cdWasRentedAtOn(String cdId, String time, String date) throws FormatDeviation {
	  physicalID = PhysicalIDADT.parseString(cdId); 
	  CD cd = CDAccess.findByPhysicalID(physicalID); 
	  theTimeStamp = makeTimeStamp(date, time); 
	  if (cd.getStartTime().equals(theTimeStamp))
		  return true; 
	  else
		  return false;
  }

  public boolean rentalContractForShouldHaveLineWithNameCdIdTitleDueDateDueTime(
    String  user, String name, String cdid, String title, String dueDate, String dueTime) throws FormatDeviation {
	  customerId  = CustomerIDADT.parseString(user); 
	  physicalID= PhysicalIDADT.parseString(cdid);
	  Name n = Name.parseString(name); 
	  Name t = Name.parseString(title); 
	 
	  TimeStamp dueTimeStemp = makeTimeStamp(dueDate, dueTime); 	
	RentalContract current = 
	 new RentalContract(n, t, physicalID, customerId, dueTimeStemp); 
	return current.testEquals(theRentalForm); 
  }

  public void returnCdAtOn(String cd, String time, String date) throws FormatDeviation {
	  	setTime(time); 
	  	setDate(date); 
		physicalID = PhysicalIDADT.parseString(cd); 
		theRentalChargeForm = RentalProcess.checkIn( physicalID); 

  }

  public boolean cdIsNotRented(String cdid) throws FormatDeviation {
	  physicalID = PhysicalIDADT.parseString(cdid); 
	cd = CDAccess.findByPhysicalID(physicalID);  
	if (!cd.getRented().equals(YesNo.NO))
		return false; 
	else
		return true; 
  }

///  |receipt for|@CUSTOMERID|should have line with name|@CUSTOMERNAME|cd id|@CDID|title|@CDTITLE|return date|@RETURN_DATE|return time|@RETURN_TIME|for fee|@FEE|
///   receipt for|@CUSTOMERID|should have line with name|@CUSTOMERNAME|cd id|@CDID|title|@CDTITLE|return date|@RETURN_DATE|return time|@RETURN_TIME|for fee|@FEE|

  public boolean receiptForShouldHaveLineWithNameCdIdTitleReturnDateReturnTimeForFee(
      String  userid, String name, String cdid, String title, String returnDate, String returnTime, String fee) 
  		throws FormatDeviation {
	  customerId  = CustomerIDADT.parseString(userid); 
	  physicalID= PhysicalIDADT.parseString(cdid);
	  Name n = Name.parseString(name); 
	  Name t = Name.parseString(title); 
	 
	  TimeStamp returnTimeStemp = makeTimeStamp(returnDate, returnTime); 
	  Dollar theFee  = Dollar.parseString(fee); 
	  RentalCharge other = new RentalCharge( n, t, returnTimeStemp, theFee); 		
	  theRentalChargeForm.testEquals(other); 
	  return true; 
     }
}
